{{- $allowedTypes := slice "note" "flag" "warning" "disclaimer" -}}
{{- $type := .Get "type" -}}

{{- partial "functions/validate-shortcode.html" (dict "shortcodeName" "alert" "allowedValues" $allowedTypes "paramName" "type" "paramValue" $type "sourceFile" .Position.Filename "lineNumber" .Position.LineNumber) -}}

<div class="alert alert-type-{{ (.Get "type") }}">
  {{- if eq (.Get "type") "disclaimer" -}}
    {{ T "alerts.disclaimerTxt" }}
  {{- else -}}
    {{/*
      When alert shortcodes are used in indented contexts (like nested lists),
      Hugo's markdown processor sees the indented content first and converts it
      to a code block (wrapping it in <pre><code>) before processing the shortcode.

      To prevent this, we:
      1. Remove all leading whitespace/indentation that would trigger code block processing
      2. Then render the content after removing the problematic indentation

      This ensures the content is processed as regular text rather than a code block,
      while maintaining the proper rendering of any actual markdown within the alert.
    */}}
    <!-- Supports multiline text. Credit: https://gohugo.io/methods/page/renderstring/ -->
    {{- $opts := dict "display" "block" -}}
    {{- .InnerDeindent | .Page.RenderString $opts -}}
  {{- end -}}
</div>
